/*
** Contains general purpose macros and inclusion.
**
** $Id: ant_general.h,v 1.11 2001/02/21 20:31:54 kilobug Exp $
*/

#ifndef __ANT_GENERAL_H__
#define __ANT_GENERAL_H__ 

#ifdef HAVE_CONFIG_H
# include <config.h>
# ifdef HAVE_STDLIB_H
#  include <stdlib.h>
# endif
# ifdef HAVE_STDIO_H
#  include <stdio.h>
# endif
# ifdef HAVE_UNISTD_H
#  include <unistd.h>
# endif
# ifdef HAVE_STRING_H
#  include <string.h>
# endif
# ifdef HAVE_ERRNO_H
#  include <errno.h>
# else
   extern int errno;
# endif
# ifdef HAVE_ERRNO_H
#  include <fcntl.h>
# endif
#else
# include <stdlib.h>
# include <stdio.h>
# include <unistd.h>
# include <string.h>
# include <errno.h>
# include <fcntl.h>
#endif

#include <pthread.h>
#include <glib.h>
#include <gmodule.h>

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifndef MIN
#define MIN(Var1, Var2) (((Var1) > (Var2)) ? (Var2) : (Var1))
#endif
#ifndef MAX
#define MAX(Var1, Var2) (((Var1) > (Var2)) ? (Var1) : (Var2))
#endif

#define ALLOC(P) ((P) = g_malloc(sizeof(*(P))))
#define SAFE_FREE(P) { if ((P) != NULL) { g_free(P); (P) = NULL; } }

int s_strcasecmp(const char *s1, const char *s2);

#endif
