/*
** General callbacks for the GTK+ interface.
**
** $Id: ant_gtk_callbacks.c,v 1.4 2001/02/21 21:07:25 kilobug Exp $
*/

#include "ant_gtk.h"

/* Destroy target widget */
void ant_destroy_widget(GtkWidget *w, gpointer data)
{
  gtk_widget_destroy(data);  
}

/* Hide target widget */
void ant_hide_widget(GtkWidget *w, gpointer data)
{
  gtk_widget_hide(data);  
}

/* Bye bye */
void ant_do_exit(GtkWidget *w, gpointer data)
{
  gtk_exit(0);
}

/* Config panel callbacks */
void ant_set_data_from_entry(GtkWidget *w, char **data)
{
  g_mutex_lock(ants_mutex);
  SAFE_FREE(*data);
  *data = strdup(gtk_entry_get_text(GTK_ENTRY(w)));
  g_mutex_unlock(ants_mutex);
}

void ant_set_data_from_toggle(GtkWidget *w, int *data)
{
  g_mutex_lock(ants_mutex);
  *data = (GTK_TOGGLE_BUTTON(w)->active);
  g_mutex_unlock(ants_mutex);
}

void ant_set_data_from_spin(GtkWidget *w, int *data)
{
  g_mutex_lock(ants_mutex);
  *data = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(w));
  g_mutex_unlock(ants_mutex);
}

