/*
** Some dialog boxes.
**
** $Id: ant_gtk_dialog.c,v 1.8 2001/02/21 21:07:25 kilobug Exp $
*/

#include "ant_gtk.h"

/* Display the about dialog box */
void ant_gtk_disp_about(GtkWidget *w, gpointer data)
{
  GtkWidget *dialog;
  GtkWidget *widget;
  GtkAccelGroup *accel_group;

  dialog = gtk_dialog_new();
  accel_group = gtk_accel_group_new();
  gtk_window_add_accel_group(GTK_WINDOW(&(GTK_DIALOG(dialog)->window)), 
			     accel_group);
  gtk_container_set_border_width(GTK_CONTAINER(&(GTK_DIALOG(dialog)->window)),
				 7);
  gtk_window_set_title(GTK_WINDOW(&(GTK_DIALOG(dialog)->window)), 
				  "Ants simulator");
  widget = gtk_label_new("Ants simulator version "VERSION
			 "\n\nContact: le-mig_g@epita.fr");
  gtk_widget_show(widget);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), widget, TRUE, TRUE, 9);
  widget = gtk_button_new_with_label(" OK ");
  gtk_widget_add_accelerator(widget, "clicked", accel_group, GDK_Return, 0,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_show(widget);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), widget, TRUE, 
		     TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(widget), "clicked", 
		     GTK_SIGNAL_FUNC(ant_destroy_widget), dialog); 
  gtk_widget_show(dialog);
}

/* Display the stats dialog box */
void ant_gtk_disp_stat(GtkWidget *wi, world_t *w)
{
  GtkWidget *dialog;
  GtkWidget *widget;
  GtkAccelGroup *accel_group;
  gchar buf[420];

  dialog = gtk_dialog_new();
  gtk_container_set_border_width(GTK_CONTAINER(&(GTK_DIALOG(dialog)->window)),
				7 );
  gtk_window_set_title(GTK_WINDOW(&(GTK_DIALOG(dialog)->window)), 
				  "Ant simulator statistics");
  g_snprintf(buf, 420, " Born ants: %d \n Current ants: %d \n"
	               " Exited ants: %d \n Number of moves: %d \n", 
	     w->nb_born, w->nb_ant, w->nb_die, w->nb_live);
  accel_group = gtk_accel_group_new();
  gtk_window_add_accel_group(GTK_WINDOW(&(GTK_DIALOG(dialog)->window)), 
			     accel_group);
  widget = gtk_label_new(buf);
  gtk_widget_show(widget);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), widget, TRUE, TRUE, 9);
  widget = gtk_button_new_with_label(" OK ");
  gtk_widget_add_accelerator(widget, "clicked", accel_group, GDK_Return, 0,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_show(widget);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), widget, TRUE, 
		     TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(widget), "clicked", 
		     GTK_SIGNAL_FUNC(ant_destroy_widget), dialog); 
  gtk_widget_show(dialog);
}

/************************
** Configuration panel **
*************************/

void ant_add_conf_spin(const char *msg, GtkWidget *vbox, int *data, int min, 
		   int max)
{
  GtkWidget *hbox = NULL;
  GtkWidget *widget = NULL;
  GtkAdjustment *adj = NULL;

  adj = (GtkAdjustment *)gtk_adjustment_new(*data, min, max, 1, 10, 0);
  hbox = gtk_hbox_new(TRUE, 5);
  gtk_widget_show(widget = gtk_label_new(msg));
  gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, FALSE, 0);
  widget = gtk_spin_button_new(adj, 0.4, 0);
  gtk_signal_connect(GTK_OBJECT(widget), "changed", ant_set_data_from_spin,
		     data);
  gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, FALSE, 0);
  gtk_widget_show(widget);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 0);
}

void ant_add_conf_coord(const char *msg, GtkWidget *vbox, coord_t *d, 
			coord_t *s)
{
  GtkWidget *hbox = NULL;
  GtkWidget *widget = NULL;
  GtkAdjustment *adj = NULL;

  hbox = gtk_hbox_new(FALSE, 5);
  gtk_widget_show(widget = gtk_label_new(msg));
  gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, TRUE, 0);

  gtk_widget_show(widget = gtk_label_new("X: "));
  gtk_box_pack_start(GTK_BOX(hbox), widget, FALSE, FALSE, 0);
  adj = (GtkAdjustment *)gtk_adjustment_new(d->x, 0, s->x - 1, 1, 10, 0);
  widget = gtk_spin_button_new(adj, 0.4, 0);
  gtk_signal_connect(GTK_OBJECT(widget), "changed", ant_set_data_from_spin,
		     &(d->x));
  gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, FALSE, 0);
  gtk_widget_show(widget);

  gtk_widget_show(widget = gtk_label_new("Y: "));
  gtk_box_pack_start(GTK_BOX(hbox), widget, FALSE, FALSE, 0);
  adj = (GtkAdjustment *)gtk_adjustment_new(d->y, 0, s->y - 1, 1, 10, 0);
  widget = gtk_spin_button_new(adj, 0.4, 0);
  gtk_signal_connect(GTK_OBJECT(widget), "changed", ant_set_data_from_spin,
		     &(d->y));
  gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, FALSE, 0);
  gtk_widget_show(widget);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 0);
}

void ant_add_conf_delay(const char *msg, GtkWidget *vbox, delay_t *d)
{
  GtkWidget *hbox = NULL;
  GtkWidget *widget = NULL;
  GtkAdjustment *adj = NULL;

  hbox = gtk_hbox_new(FALSE, 5);
  gtk_widget_show(widget = gtk_label_new(msg));
  gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, TRUE, 0);

  gtk_widget_show(widget = gtk_label_new("Min: "));
  gtk_box_pack_start(GTK_BOX(hbox), widget, FALSE, FALSE, 0);
  adj = (GtkAdjustment *)gtk_adjustment_new(d->min, 1, 1000000, 1, 100, 0);
  widget = gtk_spin_button_new(adj, 0.4, 0);
  gtk_signal_connect(GTK_OBJECT(widget), "changed", ant_set_data_from_spin,
		     &(d->min));
  gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, FALSE, 0);
  gtk_widget_show(widget);

  gtk_widget_show(widget = gtk_label_new("Max: "));
  gtk_box_pack_start(GTK_BOX(hbox), widget, FALSE, FALSE, 0);
  adj = (GtkAdjustment *)gtk_adjustment_new(d->max, 1, 1000000, 1, 100, 0);
  widget = gtk_spin_button_new(adj, 0.4, 0);
  gtk_signal_connect(GTK_OBJECT(widget), "changed", ant_set_data_from_spin,
		     &(d->max));
  gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, FALSE, 0);
  gtk_widget_show(widget);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, FALSE, 0);
}

/* Display the options dialog box */
void ant_gtk_show_options(GtkWidget *wid, gpointer data)
{
  static GtkWidget *opt = NULL;
  GtkWidget *vbox = NULL;
  GtkWidget *widget = NULL;
  world_t *world;
  GtkAccelGroup *accel_group;

  ant_set_status("Automatic entering pause mode.");
  ant_gtk_thread_lock();
  if ((world = data) == NULL)
    {
      ant_set_status("Internal error (assertion `data != NULL' failed).");
      return;
    }
  if (opt != NULL)
    {
      gtk_widget_show(opt);
      return;
    }
  opt = gtk_window_new(GTK_WINDOW_DIALOG);
  accel_group = gtk_accel_group_new();
  gtk_window_add_accel_group(GTK_WINDOW(opt),  accel_group);
  gtk_container_set_border_width(GTK_CONTAINER(opt), 7);
  gtk_signal_connect(GTK_OBJECT(opt), "delete_event", 
		     GTK_SIGNAL_FUNC(gtk_widget_hide), NULL);
  gtk_window_set_title(GTK_WINDOW(opt), "Ants simulation configuration");
  vbox = gtk_vbox_new(TRUE, 5);
  gtk_widget_show(vbox);

  ant_add_conf_spin("Maximal number of ants:", vbox, 
		    &(world->rules->nb_ant_max), -1, 1000000);
  ant_add_conf_spin("Maximal ants per cell:", vbox, 
		    &(world->rules->max_by_cell), -1, 1000000);
  ant_add_conf_coord("Entry point:", vbox, &(world->rules->entry), 
		     &(world->size));
  ant_add_conf_delay("Creation delay (ms):", vbox, &(world->rules->create));
  ant_add_conf_delay("Cycle delay (ms):", vbox, &(world->rules->live));

  widget = gtk_button_new_with_label("Close window");
  gtk_widget_add_accelerator(widget, "clicked", accel_group, GDK_Return, 0,
                              GTK_ACCEL_VISIBLE);
  gtk_widget_show(widget);
  gtk_box_pack_start(GTK_BOX(vbox), widget, TRUE, FALSE, 5);
  gtk_signal_connect(GTK_OBJECT(widget), "clicked", 
		     GTK_SIGNAL_FUNC(ant_hide_widget), opt);
  gtk_container_add(GTK_CONTAINER(opt), vbox);  
  gtk_widget_show(opt);
}

