/*
** Private .h for GTK main graphical box ant stats.
**
** $Id: ant_gtk_mainbox.h,v 1.3 2001/02/24 15:53:42 kilobug Exp $
*/

#ifndef __ANT_GTK_MAINBOX_H__
#define __ANT_GTK_MAINBOX_H__

typedef struct ant_gfx_entry_s
{
  int curval;
  GtkEntry *entry;
  GtkWidget *lbl;
  int *val;
  int *dep;
} ant_gfx_entry_t;

typedef struct ant_gfx_progress_s
{
  int curval;
  int curmax;
  GtkProgress *progress;
  GtkWidget *lbl;
  int *val;
  int *max;
  int *dep;
} ant_gfx_progress_t;

/* Main structure */
typedef struct ant_gfx_drawing_s
{
  world_t *world;
  int cs;
  GtkWidget *drawing_area;
  GdkPixmap *pixmap;
  ant_gfx_entry_t *nbl, *nbd, *nbc, *nba;
  ant_gfx_progress_t *exit_ratio;
  ant_gfx_entry_t *wood_map, *wood_home;
  ant_gfx_progress_t *wood_ratio;
  GdkGC *line;
  GdkGC *back;
  GdkGC *entry;
  GdkGC *exit;
  GdkGC *wall;
  GdkGC *ant;
  GdkGC *wood;
  GdkGC *wood_fix;
  GdkGC *home;
  GdkFont *font;
} ant_gfx_drawing_t;

/* Create an entry with a label and link it to the table */
ant_gfx_entry_t *ant_gfx_create_entry(GtkWidget *table, const char *label,
				      int *val, int *dep, int x, int y);

/* Create an progress bar with a label and link it to the table */
ant_gfx_progress_t *ant_gfx_create_progress(GtkWidget *table, const char *lbl,
					    int *val, int *max,
					    int *dep, int y);

/* Update an entry */
void ant_gfx_entry_update(ant_gfx_entry_t *entry);

/* Update a progress bar */
void ant_gfx_progress_update(ant_gfx_progress_t *p);

#endif
