/*
** The GTK+ interface: interface creating functions.
**
** $Id: ant_gtk_menu.c,v 1.7 2001/02/21 21:07:25 kilobug Exp $
*/

#include "ant_gtk.h"

void ant_gtk_kill_callback(GtkWidget *wi, world_t *w)
{
  ant_kill_all_ants(w);
}

void ant_gtk_reset_callback(GtkWidget *wi, world_t *w)
{
  ant_kill_all_ants(w);
  w->nb_live = w->nb_die = w->nb_born = 0;
}

static GtkItemFactoryEntry gtk_menu_items[] = {
      { "/_File",               NULL,         NULL, 0, "<Branch>" },
      { "/File/_Options",       "<control>O", ant_gtk_show_options, 0, NULL },
      { "/File/sep1",           NULL,         NULL, 0, "<Separator>" },
      { "/File/_Quit",          "<control>Q", ant_do_exit, 0, NULL },
      { "/_Simulation",         NULL,         NULL, 0, "<Branch>" },
      { "/Simulation/_Pause",   "<control>P", ant_gtk_lock_callback, 0, NULL },
      { "/Simulation/_Unpause", "<control>U", ant_gtk_unlock_callback, 
	0, NULL },
      { "/Simulation/_Step",    "<control>S", ant_gtk_step_callback, 0, NULL },
      { "/Simulation/sep1",     NULL,         NULL, 0, "<Separator>" },
      { "/Simulation/S_tats",    "<control>T", ant_gtk_disp_stat, 0, NULL },
      { "/Simulation/sep1",     NULL,         NULL, 0, "<Separator>" },
      { "/Simulation/_Kill ants","<control>K", ant_gtk_kill_callback, 
	0, NULL },
      { "/Simulation/_Reset",   "<control>R", ant_gtk_reset_callback, 
	0, NULL },
      { "/_Help",               NULL,         NULL, 0, "<LastBranch>" },
      { "/_Help/_About",        NULL,         ant_gtk_disp_about, 0, NULL },
    };

GtkWidget *ant_make_menubar(GtkWidget *window, world_t *w)
{
  GtkItemFactory *item_factory = NULL;
  GtkAccelGroup	*accel_group  = NULL;
  GtkWidget *widget = NULL;
  int nmenu_items;

  nmenu_items = sizeof (gtk_menu_items) / sizeof (gtk_menu_items[0]);
  accel_group = gtk_accel_group_new();
  item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", 
				      accel_group);
  gtk_item_factory_create_items_ac(item_factory, nmenu_items, gtk_menu_items, 
				   w, 2);
  gtk_window_add_accel_group(GTK_WINDOW(window), accel_group);
  widget = gtk_item_factory_get_widget(item_factory, "<main>");
  gtk_widget_show(widget);
  return widget;
}

