/*
** Contains the interface between the GTK thread and the world.
**
** $Id: ant_gtk_public.h,v 1.10 2001/02/22 01:25:14 kilobug Exp $
*/

#ifndef __ANT_GTK_PUBLIC_H__
#define __ANT_GTK_PUBLIC_H__

#ifndef __ANT_H__
#error "MUST BE INCLUDED FROM ANT.H"
#endif

#ifdef __USE_GTK__
#include <gtk/gtk.h>
#define ant_main_loop ant_main_loop_gtk
#define ant_main_loop_init ant_gtk_loop_init
#define ant_action_begin ant_gtk_action_begin
#define ant_action_end ant_gtk_action_end
#define ant_cell_has_changed ant_gtk_redraw_cell
#define ant_stats_have_changed ant_gtk_stats_refresh
void ant_disp_msg(const char *fmt, ...);

void ant_main_loop_gtk(world_t *w);
void ant_gtk_action_begin(world_t *w);
void ant_gtk_action_end(world_t *w);
void ant_gtk_loop_init(int *argc, char ***argv);
void ant_gtk_redraw_cell(world_t *w, int x, int y);
void ant_gtk_stats_refresh(world_t *w);
#else
#define ant_main_loop ant_main_loop_default
#define ant_main_loop_init(ARGC, ARGV)
#define ant_action_begin(W)
#define ant_action_end(W)
#define ant_stats_have_changed(W)
#define ant_cell_has_changed(W, X, Y)
#define ant_disp_msg printf
#endif

#endif
