/*
** Parser specific .h file.
**
** $Id: ant_parser.h,v 1.4 2001/02/21 20:42:46 kilobug Exp $
*/

#ifndef __ANT_PARSER_H__
#define __ANT_PARSER_H__

#ifndef __ANT_GENERAL_H__
#error "MUST BE INCLUDED AFTER ANT_GENERAL.H"
#endif

#define SCOPE_NONE	0
#define SCOPE_NUM	1
#define SCOPE_POS	2
#define SCOPE_SIZE	3
#define SCOPE_DELAY	4
#define SCOPE_POS_ELEM	5

struct ant_parser_s
{
  const char *section;
  const char *name;
  int offset;
  enum { pt_int, pt_string, pt_coord, pt_delay, pt_none } type;
  guint scope_id;
};

extern struct ant_parser_s ant_config_file[];

error_t ant_parser_get_value(GScanner *scan, rules_t *rules, 
			     const char *section);

#define PARSER_CHECK_TYPE(WHAT, TYPE) {\
  if (WHAT != TYPE)\
    {\
      g_scanner_unexp_token(scan, TYPE, NULL, NULL, NULL, NULL, TRUE);\
      return ERROR_PARSE;\
    }\
}

#endif
