/*
** Contains types and prototypes for internal usage only.
**
** $Id: ant_private.h,v 1.7 2001/02/25 18:04:10 kilobug Exp $
*/

#ifndef __ANT_PRIVATE_H__
#define __ANT_PRIVATE_H__

#include "ant.h"

/* Used as library or an executable loading dynamic plugins */
typedef enum { lvl_lib, lvl_plugin } ant_run_level_t;
extern ant_run_level_t ant_run_level;

/* Same as add_item, but don't call the ant_cell_has_changed callback */
void ant_do_add_item(world_t *w, const coord_t *where, content_type_t type, 
		     int par);

/* The main command line parser */
void ant_parse_cmdline(int argc, const char **argv, rules_t *res);

/**********************
 ** Action internals **
 **********************/

/* Do absolutely nothing */
error_t	ant_do_nothing(ant_t *ant, const void *param);

/* Move ant to "where" */
error_t	ant_move_to(ant_t *ant, const coord_t *where);

/* Push wood to "where" */
error_t	ant_push_to(ant_t *ant, const coord_t *where);

/* Push or move */
error_t	ant_push_move_to(ant_t *ant, const coord_t *where);

#endif
