/*
** Contains prototype of world functions.
**
** $Id: ant_world.h,v 1.14 2001/02/22 01:25:14 kilobug Exp $
*/

#ifndef __ANT_WORLD_H__
#define __ANT_WORLD_H__

#ifndef __ANT_H__
#error "MUST BE INCLUDED FROM ANT.H"
#endif

/*************
 ** Actions **
 *************/

/* Perform an action */
error_t ant_action(ant_t *ant, int action, void *param);

/* Add an action to the list of known actions */
error_t ant_add_action(world_t *w, int action, ant_action_func_t *func);

/********************
 ** World handling **
 ********************/

/* Create an empty world from the rules */
world_t *ant_create_world(rules_t *rules);

/* Returns the distance between two points (in norm 1) */
int ant_dist(const coord_t *a, const coord_t *b);

/* Returns TRUE if an ant can go to this cell */
int ant_cell_empty(const world_t *w, const coord_t *where);

/* Add an item at the following coords */
void ant_add_item(world_t *w, const coord_t *where, content_type_t type, 
		  int par);

/* Delete an item from the world */
void ant_delete_item(world_t *w, const coord_t *where, 
		     content_type_t type, int par);

/* Find an item */
content_t *ant_find_item(const world_t *w, const coord_t *where, 
			 content_type_t type);

#endif
